# std::basic_string<CharT,Traits,Allocator>::end, std::basic_string<CharT,Traits,Allocator>::cend

From cppreference.com
< cpp‎ | string‎ | basic string

| (1) |
iterator end(); |  | (until C++11)
iterator end() noexcept; |  | (since C++11)
| (2) |
const_iterator end() const; |  | (until C++11)
const_iterator end() const noexcept; |  | (since C++11)
const_iterator cend() const noexcept; | (3) | (since C++11)

Returns an iterator to the character following the last character of the string. This character acts as a placeholder, attempting to access it results in undefined behavior.

### Parameters

(none)

### Return value

iterator to the character following the last character

### Complexity

Constant

### Example

Run this code

    #include <iostream>
    #include <algorithm>
    #include <iterator>
    #include <string>

    int main()
    {
        std::string s("Exemparl");
        std::next_permutation(s.begin(), s.end());

        std::string c;
        std::copy(s.cbegin(), s.cend(), std::back_inserter(c));
        std::cout << c <<'\n'; // "Exemplar"
    }

Output:

    Exemplar

### See also

begincbegin (C++11) | returns an iterator to the beginning (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/string/basic_string/end&oldid=110142"